Index: branches/network/src/story_entities/campaign.cc
===================================================================
--- branches/network/src/story_entities/campaign.cc	(revision 6404)
+++ branches/network/src/story_entities/campaign.cc	(revision 6407)
@@ -77,6 +77,4 @@
   this->isRunning = true;
   this->run();
-
-  PRINTF(2)("There is no StoryEnity left to play, quitting\n");
 }
 
@@ -130,8 +128,10 @@
 
     this->currentEntity->init();
+
     this->currentEntity->loadData();
     this->currentEntity->start();
     this->currentEntity->unloadData();
   }
+  PRINTF(2)("There is no StoryEnity left to play, quitting\n");
 }
 
Index: branches/network/src/story_entities/campaign_data.cc
===================================================================
--- branches/network/src/story_entities/campaign_data.cc	(revision 6404)
+++ branches/network/src/story_entities/campaign_data.cc	(revision 6407)
@@ -33,4 +33,5 @@
 
   this->currentEntity = NULL;
+
   this->loadParams(root);
 }
@@ -42,14 +43,13 @@
 CampaignData::~CampaignData()
 {
-  PRINTF(3)("Deleting CampaignData\n");
+  PRINTF(4)("Deleting CampaignData\n");
   while( !this->storyEntities.empty())
   {
     StoryEntity* bo = this->storyEntities.back();
     this->storyEntities.pop_back();
-    PRINTF(3)("CampaignData is been deleted: nr %i\n", bo->getStoryID());
+    PRINTF(4)("CampaignData is been deleted: nr %i\n", bo->getStoryID());
     delete bo;
   }
 }
-
 
 
@@ -58,7 +58,7 @@
  * @param root: The XML-element to load from
  */
-void CampaignData::loadData(const TiXmlElement* root)
+void CampaignData::loadParams(const TiXmlElement* root)
 {
-  LoadParamXML(root, "WorldList", this, CampaignData, loadParamsWorldList)
+  LoadParamXML(root, "WorldList", this, CampaignData, loadData)
       .describe("A List of Worlds to be loaded in this Campaign");
 }
@@ -69,5 +69,5 @@
  * @param root: the XML-element to load from
  */
-void CampaignData::loadParamsWorldList(const TiXmlElement* root)
+void CampaignData::loadData(const TiXmlElement* root)
 {
   if( root == NULL)
@@ -79,4 +79,5 @@
     if( created != NULL)
       this->addStoryEntity(created);
+    PRINTF(4)("Created a new StoryEntity and added it to the Campaign: id=%i\n", created->getStoryID());
   }
   LOAD_PARAM_END_CYCLE(element);
Index: branches/network/src/story_entities/campaign_data.h
===================================================================
--- branches/network/src/story_entities/campaign_data.h	(revision 6404)
+++ branches/network/src/story_entities/campaign_data.h	(revision 6407)
@@ -21,4 +21,6 @@
     virtual ~CampaignData();
 
+    void loadParams(const TiXmlElement* root);
+
     void loadData(const TiXmlElement* root);
 
@@ -27,8 +29,4 @@
     StoryEntity* getFirstLevel();
     StoryEntity* getNextLevel();
-
-
-  private:
-    void loadParamsWorldList(const TiXmlElement* root);
 
 
Index: branches/network/src/story_entities/game_world.cc
===================================================================
--- branches/network/src/story_entities/game_world.cc	(revision 6404)
+++ branches/network/src/story_entities/game_world.cc	(revision 6407)
@@ -90,5 +90,5 @@
   this->path = NULL;
 
-  this->gameWorldData = new GameWorldData();
+  //this->dataTank = new GameWorldData();
 }
 
@@ -101,6 +101,6 @@
 GameWorld::~GameWorld ()
 {
-  if( this->gameWorldData)
-    delete this->gameWorldData;
+  if( this->dataTank)
+    delete this->dataTank;
 
   PRINTF(0)("Deleted GameWorld\n");
@@ -136,5 +136,5 @@
   this->shell = new Shell();
 
-  this->gameWorldData->init();
+  this->dataTank->init();
 }
 
@@ -146,4 +146,6 @@
 {
   this->displayLoadScreen();
+
+  PRINTF(0)("Loading the GameWorld\n");
 
   PRINTF(3)("> Loading world: '%s'\n", getPath());
@@ -176,5 +178,5 @@
   }
   /* the whole loading process for the GameWorld */
-  this->gameWorldData->loadData(root);
+  this->dataTank->loadData(root);
 
   delete XMLDoc;
@@ -191,5 +193,5 @@
   PRINTF(3)("GameWorld::~GameWorld() - unloading the current GameWorld\n");
 
-  this->gameWorldData->unloadData();
+  this->dataTank->unloadData();
 }
 
@@ -330,12 +332,12 @@
     this->gameTime += this->dtS;
 
-    this->tick(this->gameWorldData->objectManager->getObjectList(OM_DEAD_TICK), this->dtS);
-    this->tick(this->gameWorldData->objectManager->getObjectList(OM_COMMON), this->dtS);
-    this->tick(this->gameWorldData->objectManager->getObjectList(OM_GROUP_00), this->dtS);
-    this->tick(this->gameWorldData->objectManager->getObjectList(OM_GROUP_01), this->dtS);
-    this->tick(this->gameWorldData->objectManager->getObjectList(OM_GROUP_01_PROJ), this->dtS);
+    this->tick(this->dataTank->objectManager->getObjectList(OM_DEAD_TICK), this->dtS);
+    this->tick(this->dataTank->objectManager->getObjectList(OM_COMMON), this->dtS);
+    this->tick(this->dataTank->objectManager->getObjectList(OM_GROUP_00), this->dtS);
+    this->tick(this->dataTank->objectManager->getObjectList(OM_GROUP_01), this->dtS);
+    this->tick(this->dataTank->objectManager->getObjectList(OM_GROUP_01_PROJ), this->dtS);
 
     /* update tick the rest */
-    this->gameWorldData->localCamera->tick(this->dtS);
+    this->dataTank->localCamera->tick(this->dtS);
     AnimationPlayer::getInstance()->tick(this->dtS);
     ParticleEngine::getInstance()->tick(this->dtS);
@@ -368,8 +370,8 @@
 void GameWorld::collide()
 {
-  CDEngine::getInstance()->checkCollisions(this->gameWorldData->objectManager->getObjectList(OM_GROUP_00),
-      this->gameWorldData->objectManager->getObjectList(OM_GROUP_01_PROJ));
-  CDEngine::getInstance()->checkCollisions(this->gameWorldData->objectManager->getObjectList(OM_GROUP_01),
-      this->gameWorldData->objectManager->getObjectList(OM_COMMON));
+  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_GROUP_00),
+      this->dataTank->objectManager->getObjectList(OM_GROUP_01_PROJ));
+  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_GROUP_01),
+      this->dataTank->objectManager->getObjectList(OM_COMMON));
 }
 
@@ -384,5 +386,5 @@
   glClear( GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
   // set camera
-  this->gameWorldData->localCamera->apply ();
+  this->dataTank->localCamera->apply ();
   // draw world
   this->draw();
@@ -456,6 +458,6 @@
 {
   PRINTF(3)("GameWorld::displayLoadScreen - start\n");
-  this->gameWorldData->glmis = new GLMenuImageScreen();
-  this->gameWorldData->glmis->setMaximum(8);
+  this->dataTank->glmis = new GLMenuImageScreen();
+  this->dataTank->glmis->setMaximum(8);
   PRINTF(3)("GameWorld::displayLoadScreen - end\n");
 }
@@ -468,5 +470,5 @@
 {
   PRINTF(3)("GameWorld::releaseLoadScreen - start\n");
-  this->gameWorldData->glmis->setValue(this->gameWorldData->glmis->getMaximum());
+  this->dataTank->glmis->setValue(this->dataTank->glmis->getMaximum());
   PRINTF(3)("GameWorld::releaseLoadScreen - end\n");
 }
Index: branches/network/src/story_entities/game_world.h
===================================================================
--- branches/network/src/story_entities/game_world.h	(revision 6404)
+++ branches/network/src/story_entities/game_world.h	(revision 6407)
@@ -74,5 +74,5 @@
 
   protected:
-    GameWorldData*      gameWorldData;                //!< reference to the GameWorld Data Tank
+    GameWorldData*      dataTank;                     //!< reference to the GameWorld Data Tank
     char*               path;                         //!< The file from which this world is loaded
 
Index: branches/network/src/story_entities/single_player_world.cc
===================================================================
--- branches/network/src/story_entities/single_player_world.cc	(revision 6404)
+++ branches/network/src/story_entities/single_player_world.cc	(revision 6407)
@@ -42,7 +42,7 @@
   this->setName("SinglePlayerWorld uninitialized");
 
+  this->dataTank = new SinglePlayerWorldData();
+
   this->loadParams(root);
-
-  this->singlePlayerWorldData = new SinglePlayerWorldData();
 }
 
Index: branches/network/src/story_entities/single_player_world.h
===================================================================
--- branches/network/src/story_entities/single_player_world.h	(revision 6404)
+++ branches/network/src/story_entities/single_player_world.h	(revision 6407)
@@ -6,4 +6,5 @@
 #ifndef _SINGLE_PLAYER_WORLD_H
 #define _SINGLE_PLAYER_WORLD_H
+
 
 #include "game_world.h"
@@ -27,7 +28,4 @@
 
     void loadParams(const TiXmlElement* root);
-
-  private:
-    SinglePlayerWorldData*        singlePlayerWorldData;             //!< reference to the data tank
 };
 
Index: branches/network/src/story_entities/single_player_world_data.cc
===================================================================
--- branches/network/src/story_entities/single_player_world_data.cc	(revision 6404)
+++ branches/network/src/story_entities/single_player_world_data.cc	(revision 6407)
@@ -46,38 +46,4 @@
   /* call underlying function */
   GameWorldData::init();
-}
-
-
-/**
- *  loads the data from the xml file
- * @param root reference to the xml root element
- */
-ErrorMessage SinglePlayerWorldData::loadData(TiXmlElement* root)
-{
-  // load the parameters
-  // name
-  const char* string = grabParameter( root, "name");
-  if( string == NULL)
-  {
-    PRINTF(2)("GameWorld is missing a proper 'name'\n");
-    this->setName("Unknown");
-  }
-  else
-    this->setName(string);
-
-  this->loadGUI(root);
-  this->loadWorldEntities(root);
-  this->loadScene(root);
-}
-
-
-/**
- *  unloads the data from the xml file
- */
-ErrorMessage SinglePlayerWorldData::unloadData()
-{
-  this->unloadGUI();
-  this->unloadWorldEntities();
-  this->unloadScene();
 }
 
Index: branches/network/src/story_entities/single_player_world_data.h
===================================================================
--- branches/network/src/story_entities/single_player_world_data.h	(revision 6404)
+++ branches/network/src/story_entities/single_player_world_data.h	(revision 6407)
@@ -20,6 +20,4 @@
 
     virtual ErrorMessage init();
-    virtual ErrorMessage loadData(TiXmlElement* root);
-    virtual ErrorMessage unloadData();
 
 