Index: branches/avi_play_merge/src/defs/class_id.h
===================================================================
--- branches/avi_play_merge/src/defs/class_id.h	(revision 6487)
+++ branches/avi_play_merge/src/defs/class_id.h	(revision 6488)
@@ -189,4 +189,5 @@
   CL_GROUND_TURRET              =    0x00000244,
   CL_GUIDED_MISSILE             =    0x00000245,
+  CL_MOVIE_ENTITY               =    0x00000246,
 
   CL_NPC_TEST1                  =    0x00000301,
@@ -226,5 +227,5 @@
   CL_TEXTURE_SEQUENCE           =    0x00004805,
   CL_OBJ_MODEL                  =    0x00000807,
-  
+
   CL_MOVIE_PLAYER               =    0x00000805,
   CL_MEDIA_CONTAINER            =    0x00000806,
Index: branches/avi_play_merge/src/world_entities/Makefile.am
===================================================================
--- branches/avi_play_merge/src/world_entities/Makefile.am	(revision 6487)
+++ branches/avi_play_merge/src/world_entities/Makefile.am	(revision 6488)
@@ -20,4 +20,5 @@
                   world_entities/terrain.cc \
                   world_entities/satellite.cc \
+                  world_entities/movie_entity.cc \
                   world_entities/character_attributes.cc \
                   world_entities/test_entity.cc \
@@ -68,4 +69,5 @@
                  world_entities/terrain.h \
                  world_entities/satellite.h \
+                 world_entities/movie_entity.h \
                  world_entities/character_attributes.h \
                  world_entities/test_entity.h \
Index: branches/avi_play_merge/src/world_entities/movie_entity.cc
===================================================================
--- branches/avi_play_merge/src/world_entities/movie_entity.cc	(revision 6488)
+++ branches/avi_play_merge/src/world_entities/movie_entity.cc	(revision 6488)
@@ -0,0 +1,76 @@
+
+
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2005 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: hdavid, stefalie
+   co-programmer:
+*/
+
+#include "movie_entity.h"
+#include "fast_factory.h"
+
+using namespace std;
+
+//CREATE_FAST_FACTORY_STATIC(MovieEntity, CL_MOVIE_ENTITY);
+
+/**
+ *  standard constructor
+ */
+MovieEntity::MovieEntity (const TiXmlElement* root)
+{
+  this->setClassID(CL_MOVIE_ENTITY, "MovieEntity");
+
+  counter = 0;
+  timer = 0;
+  //this->model = (Model*) ResourceManager::getInstance()->load("cube", RP_LEVEL);
+}
+
+/**
+ *  standard destructor
+ */
+MovieEntity::~MovieEntity ()
+{
+}
+
+
+/**
+ *  this method is called every frame
+ * @param time: the time in seconds that has passed since the last tick
+
+   Handle all stuff that should update with time inside this method (movement, animation, etc.)
+ */
+void MovieEntity::tick(float time)
+{
+
+}
+
+
+/**
+ *  the entity is drawn onto the screen with this function
+
+   This is a central function of an entity: call it to let the entity painted to the screen. Just override this function with whatever you want to be drawn.
+ */
+void MovieEntity::draw() const
+{
+
+}
+
+void MovieEntity::loadParams(const TiXmlElement* root)
+{
+
+}
+
+void MovieEntity::loadMovie(const char* filename)
+{
+
+}
+
Index: branches/avi_play_merge/src/world_entities/movie_entity.h
===================================================================
--- branches/avi_play_merge/src/world_entities/movie_entity.h	(revision 6488)
+++ branches/avi_play_merge/src/world_entities/movie_entity.h	(revision 6488)
@@ -0,0 +1,44 @@
+/*!
+ * @file movie_entity.h
+ *  Definition of a Movie Screen
+ */
+
+#ifndef _MOVIE_ENTITY_H
+#define _MOVIE_ENTITY_H
+
+#include "world_entity.h"
+#include "comincl.h"
+#include "resource_manager.h"
+
+
+class MediaContainer;
+class Model;
+class Material;
+
+
+//! Basic class from which all interactive stuff in the world is derived from
+class MovieEntity : public WorldEntity
+{
+  private:
+    MediaContainer* media_container;
+    Model* model;
+    Material* material;
+
+    int counter;
+    float timer;
+    float fps;
+
+  public:
+    MovieEntity (const TiXmlElement* root);
+    ~MovieEntity ();
+
+    virtual void draw () const;
+    virtual void tick (float time);
+    void loadParams(const TiXmlElement* root);
+    void loadMovie(const char* filename);
+
+
+
+};
+
+#endif /* _MOVIE_ENTITY_H */