Index: /code/branches/pickup3/data/levels/includes/pickups.oxi
===================================================================
--- /code/branches/pickup3/data/levels/includes/pickups.oxi	(revision 6498)
+++ /code/branches/pickup3/data/levels/includes/pickups.oxi	(revision 6498)
@@ -0,0 +1,39 @@
+<PickupRepresentation
+    name = "Small Health Boost"
+    description = "Adds a small amout of health to the ship."
+    spawnerTemplate = "smallhealthpickupRepresentation"
+>
+    <pickup>
+        <HealthPickup template=smallhealthpickup />
+    </pickup>
+</PickupRepresentation>
+
+<PickupRepresentation
+    name = "Medium Health Boost"
+    description = "Adds a medium amout of health to the ship."
+    spawnerTemplate = "mediumhealthpickupRepresentation"
+>
+    <pickup>
+        <HealthPickup template=mediumhealthpickup />
+    </pickup>
+</PickupRepresentation>
+
+<PickupRepresentation
+    name = "Huge Health Boost"
+    description = "Adds a huge amout of health to the ship."
+    spawnerTemplate = "hugehealthpickupRepresentation"
+>
+    <pickup>
+        <HealthPickup template=hugehealthpickup />
+    </pickup>
+</PickupRepresentation>
+
+<PickupRepresentation
+    name = "Crazy Madness Health Boost"
+    description = "Adds a crazy amout of health to the ship."
+    spawnerTemplate = "crazyhealthpickupRepresentation"
+>
+    <pickup>
+        <HealthPickup template=crazyhealthpickup />
+    </pickup>
+</PickupRepresentation>
Index: /code/branches/pickup3/data/levels/templates/pickup_representation_templates.oxt
===================================================================
--- /code/branches/pickup3/data/levels/templates/pickup_representation_templates.oxt	(revision 6498)
+++ /code/branches/pickup3/data/levels/templates/pickup_representation_templates.oxt	(revision 6498)
@@ -0,0 +1,83 @@
+<Template name=smallhealthpickupRepresentation>
+    <PickupRepresentation>
+        <spawner-representation>
+            <StaticEntity>
+                <attached>
+                    <Billboard position="0,0,0" colour="0.5,1.0,0" material="Examples/Flare" />
+                </attached>
+            </StaticEntity>
+        </spawner-representation>
+    </PickupRepresentation>
+</Template>
+
+<Template name=smallhealthpickup>
+  <HealthPickup
+    health = 10
+    healthType = "limited"
+    activationType = "immediate"
+    durationType = "once"
+  />
+</Template>
+
+<Template name=mediumhealthpickupRepresentation>
+    <PickupRepresentation>
+        <spawner-representation>
+            <StaticEntity>
+                <attached>
+                    <Billboard position="0,0,0" colour="0,1.0,0.5" material="Examples/Flare" />
+                </attached>
+            </StaticEntity>
+        </spawner-representation>
+    </PickupRepresentation>
+</Template>
+
+<Template name=mediumhealthpickup>
+  <HealthPickup
+    health = 50
+    healthType = "limited"
+    activationType = "immediate"
+    durationType = "once"
+  />
+</Template>
+
+<Template name=hugehealthpickupRepresentation>
+    <PickupRepresentation>
+        <spawner-representation>
+            <StaticEntity>
+                <attached>
+                    <Billboard position="0,0,0" colour="0,1.0,0.5" material="Examples/Flare" />
+                </attached>
+            </StaticEntity>
+        </spawner-representation>
+    </PickupRepresentation>
+</Template>
+
+<Template name=hugehealthpickup>
+  <HealthPickup
+    health = 100
+    healthType = "limited"
+    activationType = "immediate"
+    durationType = "once"
+  />
+</Template>
+
+<Template name=crazyhealthpickupRepresentation>
+    <PickupRepresentation>
+        <spawner-representation>
+            <StaticEntity>
+                <attached>
+                    <Billboard position="0,0,0" colour="0,1.0,0.5" material="Examples/Flare" />
+                </attached>
+            </StaticEntity>
+        </spawner-representation>
+    </PickupRepresentation>
+</Template>
+
+<Template name=crazyhealthpickup>
+  <HealthPickup
+    health = 1000
+    healthType = "permanent"
+    activationType = "immediate"
+    durationType = "once"
+  />
+</Template>